<template>
  <v-app>
    <v-data-table v-bind:search="search" show-select v-model="selectedRows" :headers="headers" v-bind:items="traces"
      item-key="name" hide-default-footer disable-pagination dense>
      <template v-slot:top>
        <v-text-field v-model="search" label="Search ..."></v-text-field>
      </template>
      <template v-slot:body="{ items }">
        <tbody>
          <tr v-for="item in items" :key="item.name" class="data_table_class">
            <td>
              <v-checkbox v-model="selectedRows" :value="item" style="margin:0px;padding:0px" hide-details />
            </td>
            <td v-bind:style="rowColor(item)">{{ item.name }}</td>
            <td v-bind:style="rowColor(item)">{{ item.average }}</td>
          </tr>
        </tbody>
      </template>
    </v-data-table>
  </v-app>
</template>
<script>
import {useGlobalStore} from '../stores/globalStore.js';
import {colorStoreFactory} from '../stores/colorStoreFactory.js'
export default {
  setup() {  
    let globalStore = useGlobalStore();
    return  {globalStore,colorStoreFactory}
  },
  data() {
    return {    
      search: '',
      storePerService:null,
      selectedRows: [],
      headers: [
        {
          text: 'Nome di processo',
          align: 'start',
          sortable: true,
          value: 'name',
        },
        {
          text: 'numero di pratiché per giorno',
          value: 'average',
        },
      ]
    }
  },
  methods: {
    rowColor(item) {
      let colorHex = "#FFFFFF";
      // console.log("---------in rowColor selectdRows=",this.selectedRows[0].name);
      if (item.name in this.storePerService.colorPerTrace) {
        let color = this.storePerService.colorPerTrace[item.name];
        let check = this.selectedRows.some(sel => sel.name == item.name);
        if (check) {
          colorHex = this.rgbToHex(color.r, color.g, color.b);
        }
      }

      let style = "background-color:" + colorHex;
      return style;
    },
    componentToHex(c) {
      let hex = c.toString(16);
      return hex.length == 1 ? "0" + hex : hex;
    },
    rgbToHex(r, g, b) {
      return "#" + this.componentToHex(r) + this.componentToHex(g) + this.componentToHex(b);
    }

  },
  computed: {
    traces: function () {         
      if (this.storePerService==null) {
        return [];
      }
      console.log("->>>>>>>>>>>>>>>>>>>>>>>>>>>>> listTraces in DataTabe.vue >>>>>>>>>>>>>", this.storePerService.listActualMainTraces);
      
      let listTraces = [];
      for (let trace of this.storePerService.listActualMainTraces) {
        listTraces.push({ "name": trace.name, "average": trace.average.toFixed() });
      }     
      return listTraces
    },
    selectedService:function() {      
      return this.globalStore.selectedService;
    }
  },
  watch: {
    selectedRows: function () {
      let dict_visibility = {};      
      console.log("----this.selectedRows length", this.selectedRows.length);
      console.log("----this.traces length", this.traces.length);
      console.log("-----selectedRows=", this.selectedRows);
      

      for (let trace of this.traces) {
        let check = this.selectedRows.some(sel => sel.name == trace.name);
        if (check) {
          console.log("-------is selected=", trace.name);
          dict_visibility[trace.name] = true;
        } else {
          // console.log("-------is not selected=",trace.name);
          dict_visibility[trace.name] = false;
        }
      }
      this.storePerService.dict_visibility = dict_visibility;
    },
    selectedService: function() {
      this.storePerService= this.colorStoreFactory(this.selectedService)();
    }

  },
  created() {
    this.$emitter.on("colorsdefined", () => {  
      this.storePerService= this.colorStoreFactory(this.globalStore.selectedService)();
      console.log("-----in DataTable listActualMainTraces=",this.storePerService.listActualMainTraces);
    }); 
  }
}
</script>
<style>
.data_table_class td {
  font-size: 0.71em !important;
  height: 0 !important;
}
</style>
  
    